import setuptools

with open("README.md", "r", encoding="utf-8") as fh:
    long_description = fh.read()

setuptools.setup(
    name="omegi-instrumentation-python",
    version="0.0.3",
    author="omegi",
    author_email="canon1107@naver.com",
    description="Python Instrumentation for Automatic Error Logging",
    long_description=long_description,
    long_description_content_type="text/markdown",
    url="https://github.com/TeamOmegi/Instrumentation-Python",
    classifiers=[
        "Programming Language :: Python :: 3",
        "Operating System :: OS Independent",
    ],
    package_dir={"": "src"},
    packages=setuptools.find_packages(where="src"),
    python_requires=">=3.6",
    setup_requires=['wheel'],
    install_requires=[
        "annotated-types==0.6.0",
        "anyio==4.3.0",
        "asgiref==3.8.1",
        "certifi==2024.2.2",
        "click==8.1.7",
        "Deprecated==1.2.14",
        "dnspython==2.6.1",
        "email_validator==2.1.1",
        "exceptiongroup==1.2.1",
        "h11==0.14.0",
        "httpcore==1.0.5",
        "httptools==0.6.1",
        "httpx==0.27.0",
        "idna==3.7",
        "importlib-metadata==7.0.0",
        "Jinja2==3.1.4",
        "kafka-python==2.0.2",
        "markdown-it-py==3.0.0",
        "MarkupSafe==2.1.5",
        "mdurl==0.1.2",
        "opentelemetry-api==1.24.0",
        "opentelemetry-instrumentation==0.45b0",
        "opentelemetry-instrumentation-asgi==0.45b0",
        "opentelemetry-instrumentation-dbapi==0.45b0",
        "opentelemetry-instrumentation-django==0.45b0",
        "opentelemetry-instrumentation-elasticsearch==0.45b0",
        "opentelemetry-instrumentation-requests==0.45b0",
        "opentelemetry-instrumentation-fastapi==0.45b0",
        "opentelemetry-instrumentation-flask==0.45b0",
        "opentelemetry-instrumentation-mysql==0.45b0",
        "opentelemetry-instrumentation-wsgi==0.45b0",
        "opentelemetry-sdk==1.24.0",
        "opentelemetry-semantic-conventions==0.45b0",
        "opentelemetry-util-http==0.45b0",
        "orjson==3.10.3",
        "packaging==24.0",
        "Pygments==2.18.0",
        "python-dotenv==1.0.1",
        "PyYAML==6.0.1",
        "rich==13.7.1",
        "shellingham==1.5.4",
        "sniffio==1.3.1",
        "typer==0.12.3",
        "typing_extensions==4.11.0",
        "watchfiles==0.21.0",
        "websockets==12.0",
        "wrapt==1.16.0",
        "zipp==3.18.1",
    ]
)